import $ from 'jquery';
import asScroll from './asScroll';
import info from './info';

const NAMESPACE = 'asScroll';
const OtherAsScroll = $.fn.asScroll;

const jQueryAsScroll = function(options, ...args) {
  if (typeof options === 'string') {
    const method = options;

    if (/^_/.test(method)) {
      return false;
    } else if ((/^(get)/.test(method))) {
      const instance = this.first().data(NAMESPACE);
      if (instance && typeof instance[method] === 'function') {
        return instance[method](...args);
      }
    } else {
      return this.each(function() {
        const instance = $.data(this, NAMESPACE);
        if (instance && typeof instance[method] === 'function') {
          instance[method](...args);
        }
      });
    }
  }

  return this.each(function() {
    if (!$(this).data(NAMESPACE)) {
      $(this).data(NAMESPACE, new asScroll(this, options));
    }
  });
};

$.fn.asScroll = jQueryAsScroll;

$.asScroll = $.extend({
  setDefaults: asScroll.setDefaults,
  registerEasing: asScroll.registerEasing,
  getEasing: asScroll.getEasing,
  noConflict: function() {
    $.fn.asScroll = OtherAsScroll;
    return jQueryAsScroll;
  }
}, info);
